# OpenTok Linux SDK release notes

## New features and changes

### Version 2.22.3 -- May 2022

* This version removes some spurious logging. 

### Version 2.22.2 -- April 2022

* This version adds the ability to enable per-subscriber audio levels. See the docs for
  the `otc_subscriber_set_audio_volume()` and `otc_subscriber_get_audio_volume()` functions.  This is a beta feature.

* This version implements [scalable video](https://tokbox.com/developer/guides/scalable-video/) support for 
  screen sharing. See the `otc_publisher_settings_set_scalable_screenshare()` function. This is a beta feature.

### Version 2.22.1 -- March 2022

* This version removes support for DTLS 1.0.

### Version 2.22.0 -- March 2022

* This version adds the ability to enable [Opus DTX](https://datatracker.ietf.org/doc/html/rfc7587#section-3.1.3).
  Enabling Opus DTX can reduce bandwidth usage in streams that have long periods of silence.
  This was previously a beta feature. See the docs for the `otc_publisher_settings_set_opus_dtx()`
  function.

* This version adds the ability to turn off audio processing. See the docs for the
  `otc_publisher_settings_set_auto_gain_control()`, `otc_publisher_settings_set_noise_suppression()`,
  and `otc_publisher_settings_set_echo_cancellation()` functions.

* This version adds the ability to get subscriber audio data. See the docs for
  the `on_audio_data` callback function of the `otc_subscriber_callbacks` struct.

* This version removes support for cipher TLS_RSA_WITH_3DES_EDE_CBC_SHA.

### Version 2.21.2 -- November 2021

* This version fixes an issue in relayed sessions where the audio bitrate set with
  the `otc_publisher_set_max_audio_bitrate()` function was not being respected.

### Version 2.21.1 -- October 2021

* This version adds the ability to enable [Opus DTX](https://datatracker.ietf.org/doc/html/rfc7587#section-3.1.3).
  Enabling Opus DTX can reduce bandwidth usage in streams that have long periods of silence.
  This is a <i>beta</i> feature. See the docs for the `otc_publisher_settings_set_opus_dtx()`
  function.

### Version 2.21.0 -- October 2021

* This version adds the ability to dynamically change how published video streams are optimized.
  This can improve video performance for some screen-sharing streams and in other conditions.
  See the docs for the `otc_video_capturer_get_content_hint()` and `otc_video_capturer_set_content_hint()`
  functions.

* This version adds the ability for moderators to mute participants. This was previously a
  _beta_ feature. See the docs for the `otc_session_force_mute_all()`, `otc_session_force_mute_stream()`,
  and `otc_session_disable_force_mute()` functions. Note that the `otc_session_force_mute_all()` and
  `otc_session_force_mute_stream()` functions no longer include an `options` parameter, like they did
  in the beta version.

* This version fixes an issue where an app may crash when gathering audio and video statistics for a subscriber.

### Version 2.20.0 -- July 2021

* This version adds the ability for moderators to mute participants. This is a *beta*
  feature. See the docs for the `otc_session_force_mute_all()` and `otc_session_force_mute_stream()` methods.

* This version fixes an issue where the `otc_session_unpublish()` method may fail if called immediately after publishing.

### Version 2.19.1 -- April 2021

* This version fixes an issue where a potential memory leak may occur when publishing stops.

### Version 2.19.0 -- February 2021

* This version of the SDK uses WebRTC 84, which includes improvements in performance and stability.

* This version adds support for RTC audio and video statistics for publishers and subscribers.
  See the docs for the  `otc_publisher_get_rtc_stats_report()` and `otc_subscriber_get_rtc_stats_report()`
  functions.

* This version fixes an issue where the audio bitrate value set for publishers was handled incorrectly internally.

* The [automatic reconnection feature](https://tokbox.com/developer/guides/connect-session/linux/#automatic_reconnection)
  is supported from this version onward.

### Version 2.18.1 -- October 2020

This version fixes the following issues:

* The `on_error` callback function in the `otc_publisher_callbacks` struct
  was not being triggered in all scenarios where publishing failed.

* The SDK was not proxying all communications correctly when the IP Proxy feature was being used.

### Version 2.18.0 -- August 2020

This is the first public release of OpenTok Linux SDK.

## Known issues

The following are known issues:

* If a system proxy is configured, the SDK will not use it.

* The H.264 codec is not supported. See the [video codecs](https://tokbox.com/developer/guides/codecs/)
  developer guide.
